diff --git a/channel.c b/channel.c
index 1875748..a14bcca 100644
--- a/channel.c
+++ b/channel.c
@@ -1,9 +1,9 @@
-/* 
+/*
    Copyright (C) 2009 - 2010
-   
+
    Artem Makhutov <artem@makhutov.org>
    http://www.makhutov.org
-   
+
    Dmitry Vagin <dmitry2004@yandex.ru>
 
    bg <bg_one@mail.ru>
@@ -12,10 +12,6 @@
 #include <config.h>
 #endif /* HAVE_CONFIG_H */
 
-#ifndef ASTERISK_VERSION_NUM
-#error ASTERISK_VERSION_NUM is not set, please supply -D ASTERISK_VERSION_NUM=100501 for version 10.5.1
-#endif
-
 #include <asterisk.h>
 #include <asterisk/dsp.h>			/* ast_dsp_digitreset() */
 #include <asterisk/pbx.h>			/* pbx_builtin_setvar_helper() */
@@ -29,7 +25,7 @@
 #if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
 #include <asterisk/stasis_channels.h>
 #include <asterisk/format_cache.h>
-#endif
+#endif /* ^13+ */
 
 #include "channel.h"
 #include "chan_dongle.h"
@@ -100,34 +96,45 @@ EXPORT_DEF int channels_loop(struct pvt * pvt, const struct ast_channel * reques
 	/* FIXME: requestor may be just proxy/masquerade for real channel */
 	//	use ast_bridged_channel(chan) ?
 	//	use requestor->tech->get_base_channel() ?
+	struct cpvt *tmp;
 	return (requestor
 		&& ast_channel_tech(requestor) == &channel_tech
-		&& ast_channel_tech_pvt(requestor)
-		&& ((struct cpvt*) ast_channel_tech_pvt(requestor))->pvt == pvt)
+		&& (tmp = ast_channel_tech_pvt(requestor))
+		&& tmp->pvt == pvt)
 		? 1
 		: 0;
 }
 
 #if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
-static struct ast_channel * channel_request (attribute_unused const char * type, struct ast_format_cap * cap, const struct ast_assigned_ids * assignedids, const struct ast_channel * requestor, const char * data, int * cause)
+static struct ast_channel * channel_request(
+		attribute_unused const char * type, struct ast_format_cap * cap,
+		const struct ast_assigned_ids * assignedids,
+		const struct ast_channel * requestor, const char * data, int * cause)
 #elif ASTERISK_VERSION_NUM >= 110000 /* 11+ */
-static struct ast_channel * channel_request (attribute_unused const char * type, struct ast_format_cap * cap, const struct ast_channel * requestor, const char * data, int * cause)
+static struct ast_channel * channel_request(
+		attribute_unused const char * type, struct ast_format_cap * cap,
+		const struct ast_channel * requestor, const char * data, int * cause)
 #elif ASTERISK_VERSION_NUM >= 100000 /* 10-13 */
-static struct ast_channel * channel_request (attribute_unused const char * type, struct ast_format_cap * cap, const struct ast_channel * requestor, void * data, int * cause)
+static struct ast_channel * channel_request(
+		attribute_unused const char * type, struct ast_format_cap * cap,
+		const struct ast_channel * requestor, void * data, int * cause)
 #elif ASTERISK_VERSION_NUM >= 10800 /* 1.8+ */
-//   TODO: simplify by move common code to functions
-static struct ast_channel * channel_request (attribute_unused const char * type, format_t format, const struct ast_channel * requestor, void * data, int * cause)
+static struct ast_channel * channel_request(
+		attribute_unused const char * type, format_t format,
+		const struct ast_channel * requestor, void * data, int * cause)
 #else /* 1.8- */
-/* TODO: add check when request 'holdother' what requestor is not on same device for 1.6 */
-static struct ast_channel * channel_request (attribute_unused const char * type, int format, void * data, int * cause)
-#endif
+static struct ast_channel * channel_request(
+		attribute_unused const char * type, int format, void * data, int * cause)
+#endif /* ^1.8- */
 {
+/* TODO: simplify by moving common code to functions */
+/* TODO: add check when request 'holdother' what requestor is not on same device for 1.6 */
 #if ASTERISK_VERSION_NUM >= 10800 && ASTERISK_VERSION_NUM < 100000 /* 1.8+ .. 10- */
 	format_t oldformat;
 #elif ASTERISK_VERSION_NUM < 10800 /* 1.8- */
 	int oldformat;
 	const struct ast_channel * requestor = NULL;
-#endif
+#endif /* ^1.8- */
 	char * dest_dev;
 	const char * dest_num;
 	struct ast_channel * channel = NULL;
@@ -146,23 +153,27 @@ static struct ast_channel * channel_request (attribute_unused const char * type,
 	if (ast_format_cap_iscompatible_format(cap, ast_format_slin) != AST_FORMAT_CMP_EQUAL)
 #elif ASTERISK_VERSION_NUM >= 100000 /* 10-13 */
 	if (!ast_format_cap_iscompatible(cap, &chan_dongle_format))
-#else
+#else /* 10- */
 	oldformat = format;
 	format &= AST_FORMAT_SLINEAR;
 	if (!format)
-#endif
+#endif /* ^10- */
 	{
 #if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
 		struct ast_str *codec_buf = ast_str_alloca(64);
-		ast_log (LOG_WARNING, "Asked to get a channel of unsupported format '%s'\n", ast_format_cap_get_names(cap, &codec_buf));
+		ast_log(LOG_WARNING, "Asked to get a channel of unsupported format '%s'\n",
+				ast_format_cap_get_names(cap, &codec_buf));
 #elif ASTERISK_VERSION_NUM >= 100000 /* 10-13 */
 		char buf[255];
-		ast_log (LOG_WARNING, "Asked to get a channel of unsupported format '%s'\n", ast_getformatname_multiple (buf, 255, cap));
+		ast_log(LOG_WARNING, "Asked to get a channel of unsupported format '%s'\n",
+				ast_getformatname_multiple(buf, 255, cap));
 #elif ASTERISK_VERSION_NUM >= 10800 /* 1.8+ */
-		ast_log (LOG_WARNING, "Asked to get a channel of unsupported format '%s'\n", ast_getformatname (oldformat));
-#else
-		ast_log (LOG_WARNING, "Asked to get a channel of unsupported format '%d'\n", oldformat);
-#endif
+		ast_log(LOG_WARNING, "Asked to get a channel of unsupported format '%s'\n",
+				ast_getformatname(oldformat));
+#else /* 1.8- */
+		ast_log(LOG_WARNING, "Asked to get a channel of unsupported format '%d'\n",
+				oldformat);
+#endif /* ^1.8- */
 		*cause = AST_CAUSE_FACILITY_NOT_IMPLEMENTED;
 		return NULL;
 	}
@@ -175,16 +186,19 @@ static struct ast_channel * channel_request (attribute_unused const char * type,
 
 #if ASTERISK_VERSION_NUM >= 10800
 	pvt = find_device_by_resource(dest_dev, opts, requestor, &exists);
-#else
+#else /* 1.8- */
 	pvt = find_device_by_resource(dest_dev, opts, NULL, &exists);
-#endif
+#endif /* ^1.8- */
+
 	if(pvt)
 	{
 #if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
-		channel = new_channel (pvt, AST_STATE_DOWN, NULL, pvt_get_pseudo_call_idx(pvt), CALL_DIR_OUTGOING, CALL_STATE_INIT, NULL, assignedids, requestor);
-#else
-		channel = new_channel (pvt, AST_STATE_DOWN, NULL, pvt_get_pseudo_call_idx(pvt), CALL_DIR_OUTGOING, CALL_STATE_INIT, NULL, requestor);
-#endif
+		channel = new_channel(pvt, AST_STATE_DOWN, NULL, pvt_get_pseudo_call_idx(pvt),
+				CALL_DIR_OUTGOING, CALL_STATE_INIT, NULL, assignedids, requestor);
+#else /* 13- */
+		channel = new_channel(pvt, AST_STATE_DOWN, NULL, pvt_get_pseudo_call_idx(pvt),
+				CALL_DIR_OUTGOING, CALL_STATE_INIT, NULL, requestor);
+#endif /* ^13- */
 		ast_mutex_unlock (&pvt->lock);
 		if(!channel)
 		{
@@ -204,10 +218,10 @@ static struct ast_channel * channel_request (attribute_unused const char * type,
 
 #/* */
 #if ASTERISK_VERSION_NUM >= 110000 /* 11+ */
-static int channel_call (struct ast_channel* channel, const char *dest, attribute_unused int timeout)
-#else
-static int channel_call (struct ast_channel* channel, char* dest, attribute_unused int timeout)
-#endif
+static int channel_call(struct ast_channel* channel, const char *dest, attribute_unused int timeout)
+#else /* 11- */
+static int channel_call(struct ast_channel* channel, char* dest, attribute_unused int timeout)
+#endif /* ^11- */
 {
 	struct cpvt* cpvt = ast_channel_tech_pvt(channel);
 	struct pvt* pvt;
@@ -251,11 +265,11 @@ static int channel_call (struct ast_channel* channel, char* dest, attribute_unus
 	{
 		if (CONF_SHARED(pvt, callingpres) < 0)
 		{
-#if ASTERISK_VERSION_NUM >= 10800
+#if ASTERISK_VERSION_NUM >= 10800 /* 1.8+ */
 			clir = ast_channel_connected(channel)->id.number.presentation;
-#else
+#else /* 1.8- */
 			clir = channel->cid.cid_pres;
-#endif
+#endif /* ^1.8- */
 		}
 		else
 		{
@@ -487,8 +501,9 @@ static void iov_write(struct pvt* pvt, int fd, struct iovec * iov, int iovcnt)
 			if((errno == EINTR || errno == EAGAIN))
 			{
 				--count;
-				if(count != 0)
-				    goto again;
+				if(count != 0) {
+					goto again;
+				}
 				ast_debug (1, "[%s] Deadlock avoided for write!\n", PVT_ID(pvt));
 			}
 			break;
@@ -616,7 +631,7 @@ static void write_conference(struct pvt * pvt, const char * buffer, size_t lengt
 #else /* 1.8- */
 #define subclass_codec		subclass
 #define subclass_integer	subclass
-#endif
+#endif /* ^1.8- */
 
 #/* */
 static struct ast_frame* channel_read (struct ast_channel* channel)
@@ -661,9 +676,9 @@ static struct ast_frame* channel_read (struct ast_channel* channel)
 		cpvt->a_read_frame.subclass.format = ao2_bump(ast_format_slin);
 #elif ASTERISK_VERSION_NUM >= 100000 /* 10-13 */
 		ast_format_copy(&cpvt->a_read_frame.subclass.format, &chan_dongle_format);
-#else
+#else /* 10- */
 		cpvt->a_read_frame.subclass_codec = AST_FORMAT_SLINEAR;
-#endif
+#endif /* ^10- */
 		cpvt->a_read_frame.data.ptr = cpvt->a_read_buf + AST_FRIENDLY_OFFSET;
 		cpvt->a_read_frame.offset = AST_FRIENDLY_OFFSET;
 		cpvt->a_read_frame.src = AST_MODULE;
@@ -733,9 +748,9 @@ static struct ast_frame* channel_read (struct ast_channel* channel)
 						f->subclass_integer = 0;
 					}
 					else if(f->subclass_integer == pvt->dtmf_digit
-							&& 
+							&&
 						!ast_tvzero(pvt->dtmf_end_time)
-							&& 
+							&&
 						ast_tvdiff_ms(ast_tvnow(), pvt->dtmf_end_time) < CONF_SHARED(pvt, mindtmfinterval))
 					{
 						ast_debug(1, "[%s] DTMF char %c ignored min interval %d > %ld\n", PVT_ID(pvt), f->subclass_integer, CONF_SHARED(pvt, mindtmfinterval), (long)ast_tvdiff_ms(ast_tvnow(), pvt->dtmf_end_time));
@@ -778,12 +793,15 @@ static int channel_write (struct ast_channel* channel, struct ast_frame* f)
 	int gains[2];
 
 #if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
-	if (f->frametype != AST_FRAME_VOICE || ast_format_cmp(f->subclass.format, ast_format_slin) != AST_FORMAT_CMP_EQUAL)
+	if (f->frametype != AST_FRAME_VOICE
+			|| ast_format_cmp(f->subclass.format, ast_format_slin) != AST_FORMAT_CMP_EQUAL)
 #elif ASTERISK_VERSION_NUM >= 100000 /* 10-13 */
-	if (f->frametype != AST_FRAME_VOICE || f->subclass.format.id != AST_FORMAT_SLINEAR)
+	if (f->frametype != AST_FRAME_VOICE
+			|| f->subclass.format.id != AST_FORMAT_SLINEAR)
 #else /* 10- */
-	if (f->frametype != AST_FRAME_VOICE || f->subclass_codec != AST_FORMAT_SLINEAR)
-#endif
+	if (f->frametype != AST_FRAME_VOICE
+			|| f->subclass_codec != AST_FORMAT_SLINEAR)
+#endif /* ^10- */
 	{
 		return 0;
 	}
@@ -816,9 +834,9 @@ static int channel_write (struct ast_channel* channel, struct ast_frame* f)
 	{
 #if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
 		RAII_VAR(struct ast_channel *, bridged, ast_channel_bridge_peer(channel), ast_channel_cleanup);
-#else
-		struct ast_channel* bridged = ast_bridged_channel(channel);
-#endif
+#else /* 13- */
+		struct ast_channel *bridged = ast_bridged_channel(channel);
+#endif /* ^13- */
 		struct cpvt *tmp_cpvt;
 
 		CPVT_SET_FLAGS(cpvt, CALL_FLAG_BRIDGE_CHECK);
@@ -840,8 +858,8 @@ static int channel_write (struct ast_channel* channel, struct ast_frame* f)
 	{
 		if(f->datalen)
 		{
-			/** try to minimize of ast_frame_adjust_volume() calls: 
-			 *  one hand we must obey txgain but with other divide gain to 
+			/** try to minimize of ast_frame_adjust_volume() calls:
+			 *  one hand we must obey txgain but with other divide gain to
 			 *  number of mixed channels. In some cases one call of ast_frame_adjust_volume() enough
 			*/
 
@@ -973,9 +991,9 @@ static int channel_fixup (struct ast_channel* oldchannel, struct ast_channel* ne
 #/* FIXME: must modify in conjuction with state on call not whole device? */
 #if ASTERISK_VERSION_NUM >= 110000 /* 11+ */
 static int channel_devicestate (const char *data)
-#else
+#else /* 11- */
 static int channel_devicestate (void* data)
-#endif
+#endif /* ^11- */
 {
 	char*	device;
 	struct pvt*	pvt;
@@ -1172,7 +1190,7 @@ EXPORT_DEF void change_channel_state(struct cpvt * cpvt, unsigned newstate, int
 static void set_channel_vars(struct pvt* pvt, struct ast_channel* channel)
 {
 	unsigned idx;
-	channel_var_t dev_vars[] = 
+	channel_var_t dev_vars[] =
 	{
 		{ "DONGLENAME", PVT_ID(pvt) },
 		{ "DONGLEPROVIDER", pvt->provider_name },
@@ -1183,25 +1201,29 @@ static void set_channel_vars(struct pvt* pvt, struct ast_channel* channel)
 
 #if ASTERISK_VERSION_NUM >= 110000 /* 11+  */
 	ast_channel_language_set(channel, CONF_SHARED(pvt, language));
-#else
+#else /* 11- */
 	//TODO uncomment and fix
 	//ast_string_field_set (channel, language, CONF_SHARED(pvt, language);
-#endif
+#endif /* ^11- */
 
 	for(idx = 0; idx < ITEMS_OF(dev_vars); ++idx)
 		pbx_builtin_setvar_helper (channel, dev_vars[idx].name, dev_vars[idx].value);
-
 }
 
-#/* NOTE: called from device and current levels with locked pvt */
+/* NOTE: called from device and current levels with locked pvt */
 #if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
-EXPORT_DEF struct ast_channel* new_channel (struct pvt* pvt, int ast_state, const char* cid_num, int call_idx, unsigned dir, call_state_t state, const char * dnid, const struct ast_assigned_ids *assignedids, attribute_unused const struct ast_channel * requestor)
-#else
-EXPORT_DEF struct ast_channel* new_channel (struct pvt* pvt, int ast_state, const char* cid_num, int call_idx, unsigned dir, call_state_t state, const char * dnid, attribute_unused const struct ast_channel * requestor)
-#endif
+EXPORT_DEF struct ast_channel* new_channel(
+		struct pvt* pvt, int ast_state, const char* cid_num, int call_idx,
+		unsigned dir, call_state_t state, const char * dnid,
+		const struct ast_assigned_ids *assignedids,
+		attribute_unused const struct ast_channel * requestor)
+#else /* 13- */
+EXPORT_DEF struct ast_channel* new_channel(
+		struct pvt* pvt, int ast_state, const char* cid_num, int call_idx,
+		unsigned dir, call_state_t state, const char * dnid,
+		attribute_unused const struct ast_channel * requestor)
+#endif /* ^13- */
 {
-//        struct ast_channel * channel = new_channel (pvt, AST_STATE_RING, number, call_idx, CALL_DIR_INCOMING, state, pvt->has_subscriber_number ? pvt->subscriber_number : CONF_SHARED(pvt, exten), $
-
 	struct ast_channel* channel;
 	struct cpvt * cpvt;
 
@@ -1209,16 +1231,29 @@ EXPORT_DEF struct ast_channel* new_channel (struct pvt* pvt, int ast_state, cons
 	if (cpvt)
 	{
 #if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
-                channel = ast_channel_alloc (1, ast_state, cid_num, PVT_ID(pvt), NULL, dnid, CONF_SHARED(pvt, context), assignedids, requestor, 0, "%s/%s-%02u%08lx", channel_tech.type, PVT_ID(pvt), call_idx, pvt->channel_instanse);
+		channel = ast_channel_alloc(
+				1, ast_state, cid_num, PVT_ID(pvt), NULL, dnid,
+				CONF_SHARED(pvt, context), assignedids, requestor, 0,
+				"%s/%s-%02u%08lx", channel_tech.type, PVT_ID(pvt),
+				call_idx, pvt->channel_instance);
 #elif ASTERISK_VERSION_NUM >= 10800 /* 1.8+ */
-		channel = ast_channel_alloc (1, ast_state, cid_num, PVT_ID(pvt), NULL, dnid, CONF_SHARED(pvt, context), requestor ? ast_channel_linkedid(requestor): NULL, 0, "%s/%s-%02u%08lx", channel_tech.type, PVT_ID(pvt), call_idx, pvt->channel_instanse);
-#else
-		channel = ast_channel_alloc (1, ast_state, cid_num, PVT_ID(pvt), NULL, dnid, CONF_SHARED(pvt, context), 0, "%s/%s-%02u%08lx", channel_tech.type, PVT_ID(pvt), call_idx, pvt->channel_instanse);
-#endif
+		channel = ast_channel_alloc(
+				1, ast_state, cid_num, PVT_ID(pvt), NULL, dnid,
+				CONF_SHARED(pvt, context),
+				requestor ? ast_channel_linkedid(requestor) : NULL, 0,
+				"%s/%s-%02u%08lx", channel_tech.type, PVT_ID(pvt),
+				call_idx, pvt->channel_instance);
+#else /* 1.8- */
+		channel = ast_channel_alloc(
+				1, ast_state, cid_num, PVT_ID(pvt), NULL, dnid,
+				CONF_SHARED(pvt, context), 0,
+				"%s/%s-%02u%08lx", channel_tech.type, PVT_ID(pvt),
+				call_idx, pvt->channel_instance);
+#endif /* ^1.8- */
 		if (channel)
 		{
 			cpvt->channel = channel;
-			pvt->channel_instanse++;
+			pvt->channel_instance++;
 
 			ast_channel_tech_pvt_set(channel, cpvt);
 			ast_channel_tech_set(channel, &channel_tech);
@@ -1239,7 +1274,7 @@ EXPORT_DEF struct ast_channel* new_channel (struct pvt* pvt, int ast_state, cons
 			channel->nativeformats	= AST_FORMAT_SLINEAR;
 			channel->writeformat	= AST_FORMAT_SLINEAR;
 			channel->readformat	= AST_FORMAT_SLINEAR;
-#endif
+#endif /* ^10- */
 
 			if (ast_state == AST_STATE_RING)
 			{
@@ -1329,14 +1364,14 @@ EXPORT_DEF void start_local_channel (struct pvt* pvt, const char* exten, const c
 	snprintf (channel_name, sizeof (channel_name), "%s@%s", exten, CONF_SHARED(pvt, context));
 
 #if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
-	channel = ast_request ("Local", channel_tech.capabilities, NULL, NULL, channel_name, &cause);
+	channel = ast_request("Local", channel_tech.capabilities, NULL, NULL, channel_name, &cause);
 #elif ASTERISK_VERSION_NUM >= 100000 /* 10-13 */
-	channel = ast_request ("Local", chan_dongle_format_cap, NULL, channel_name, &cause);
+	channel = ast_request("Local", chan_dongle_format_cap, NULL, channel_name, &cause);
 #elif ASTERISK_VERSION_NUM >= 10800 /* 1.8+ */
-	channel = ast_request ("Local", AST_FORMAT_AUDIO_MASK, NULL, channel_name, &cause);
+	channel = ast_request("Local", AST_FORMAT_AUDIO_MASK, NULL, channel_name, &cause);
 #else /* 1.8- */
-	channel = ast_request ("Local", AST_FORMAT_AUDIO_MASK, channel_name, &cause);
-#endif
+	channel = ast_request("Local", AST_FORMAT_AUDIO_MASK, channel_name, &cause);
+#endif /* ^1.8- */
 	if (channel)
 	{
 		set_channel_vars(pvt, channel);
@@ -1479,7 +1514,7 @@ static int channel_func_write(struct ast_channel* channel, const char* function,
 			{
 				pvt_dsp_setup(pvt, PVT_ID(pvt), val);
 			}
-			
+
 			ast_mutex_unlock(&cpvt->pvt->lock);
 		}
 		else
@@ -1500,7 +1535,7 @@ EXPORT_DEF struct ast_channel_tech channel_tech =
 	.description		= MODULE_DESCRIPTION,
 #if ASTERISK_VERSION_NUM < 100000 /* 10- */
 	.capabilities		= AST_FORMAT_SLINEAR,
-#endif
+#endif /* ^10- */
 	.requester		= channel_request,
 	.call			= channel_call,
 	.hangup			= channel_hangup,
diff --git a/channel.h b/channel.h
index 702e3f2..3ad75a2 100644
--- a/channel.h
+++ b/channel.h
@@ -7,6 +7,8 @@
 #include <asterisk.h>
 #include <asterisk/frame.h>		/* enum ast_control_frame_type */
 
+#include "ast_compat.h"			/* asterisk compatibility fixes */
+
 #include "export.h"			/* EXPORT_DECL EXPORT_DEF */
 
 
@@ -22,10 +24,17 @@ struct cpvt;
 EXPORT_DECL struct ast_channel_tech channel_tech;
 
 #if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
-EXPORT_DECL struct ast_channel* new_channel (struct pvt * pvt, int ast_state, const char * cid_num, int call_idx, unsigned dir, unsigned state, const char * exten, const struct ast_assigned_ids *assignedids, const struct ast_channel * requestor);
-#else
-EXPORT_DECL struct ast_channel* new_channel (struct pvt * pvt, int ast_state, const char * cid_num, int call_idx, unsigned dir, unsigned state, const char * exten, const struct ast_channel * requestor);
-#endif
+EXPORT_DECL struct ast_channel* new_channel(
+		struct pvt * pvt, int ast_state, const char * cid_num, int call_idx,
+		unsigned dir, unsigned state, const char * exten,
+		const struct ast_assigned_ids *assignedids,
+		const struct ast_channel * requestor);
+#else /* 13- */
+EXPORT_DECL struct ast_channel* new_channel(
+		struct pvt * pvt, int ast_state, const char * cid_num, int call_idx,
+		unsigned dir, unsigned state, const char * exten,
+		const struct ast_channel * requestor);
+#endif /* ^13- */
 EXPORT_DECL int queue_control_channel (struct cpvt * cpvt, enum ast_control_frame_type control);
 EXPORT_DECL int queue_hangup (struct ast_channel * channel, int hangupcause);
 EXPORT_DECL void start_local_channel (struct pvt * pvt, const char * exten, const char * number, channel_var_t * vars);
diff --git a/cli.c b/cli.c
index 4c25562..b13e222 100644
--- a/cli.c
+++ b/cli.c
@@ -1,9 +1,9 @@
-/* 
+/*
    Copyright (C) 2009 - 2010
-   
+
    Artem Makhutov <artem@makhutov.org>
    http://www.makhutov.org
-   
+
    Dmitry Vagin <dmitry2004@yandex.ru>
 
    bg <bg_one@mail.ru>
@@ -12,15 +12,12 @@
 #include <config.h>
 #endif /* HAVE_CONFIG_H */
 
-#ifndef ASTERISK_VERSION_NUM
-#error ASTERISK_VERSION_NUM is not set, please supply \
-	-D ASTERISK_VERSION_NUM=100501 for version 10.5.1
-#endif
-
 #include <asterisk.h>
 #include <asterisk/cli.h>			/* struct ast_cli_entry; struct ast_cli_args */
 #include <asterisk/callerid.h>			/* ast_describe_caller_presentation() */
 
+#include "ast_compat.h"				/* asterisk compatibility fixes */
+
 #include "cli.h"
 #include "chan_dongle.h"			/* devices */
 #include "helpers.h"				/* ITEMS_OF() send_ccwa_set() send_reset() send_sms() send_ussd() */
@@ -229,7 +226,7 @@ static char* cli_show_device_state (struct ast_cli_entry* e, int cmd, struct ast
 		ast_cli (a->fd, "  Current device state    : %s\n", dev_state2str(pvt->current_state) );
 		ast_cli (a->fd, "  Desired device state    : %s\n", dev_state2str(pvt->desired_state) );
 		ast_cli (a->fd, "  When change state       : %s\n", restate2str_msg(pvt->restart_time) );
-		
+
 		ast_cli (a->fd, "  Calls/Channels          : %u\n", PVT_STATE(pvt, chansno));
 		ast_cli (a->fd, "    Active                : %u\n", PVT_STATE(pvt, chan_count[CALL_STATE_ACTIVE]));
 		ast_cli (a->fd, "    Held                  : %u\n", PVT_STATE(pvt, chan_count[CALL_STATE_ONHOLD]));
@@ -337,10 +334,10 @@ static char* cli_show_device_statistics (struct ast_cli_entry* e, int cmd, struc
 /*
 		ast_cli (a->fd, "  ACD                         : %d\n",
 			getACD(
-				PVT_STAT(pvt, calls_answered[CALL_DIR_OUTGOING]) 
-				+ PVT_STAT(pvt, calls_answered[CALL_DIR_INCOMING]), 
+				PVT_STAT(pvt, calls_answered[CALL_DIR_OUTGOING])
+				+ PVT_STAT(pvt, calls_answered[CALL_DIR_INCOMING]),
 
-				PVT_STAT(pvt, calls_duration[CALL_DIR_OUTGOING]) 
+				PVT_STAT(pvt, calls_duration[CALL_DIR_OUTGOING])
 				+ PVT_STAT(pvt, calls_duration[CALL_DIR_INCOMING])
 				)
 			);
@@ -556,11 +553,11 @@ static char * cli_pdu(struct ast_cli_entry * e, int cmd, struct ast_cli_args * a
 	return CLI_SUCCESS;
 }
 
-#if ASTERISK_VERSION_NUM >= 10800
+#if ASTERISK_VERSION_NUM >= 10800 /* 1.8+ */
 typedef const char * const * ast_cli_complete2_t;
-#else
+#else /* 1.8- */
 typedef char * const * ast_cli_complete2_t;
-#endif
+#endif /* ^1.8- */
 
 static char* cli_ccwa_set (struct ast_cli_entry* e, int cmd, struct ast_cli_args* a)
 {
@@ -843,7 +840,7 @@ static char * cli_discovery(struct ast_cli_entry * e, int cmd, struct ast_cli_ar
 	const char * imsi;
 	int imeilen;
 	int imsilen;
-	
+
 	switch (cmd) {
 		case CLI_INIT:
 			e->command =	"dongle discovery";
@@ -908,7 +905,7 @@ static char * cli_discovery(struct ast_cli_entry * e, int cmd, struct ast_cli_ar
 	}
 	pdiscovery_list_end();
 	AST_RWLIST_UNLOCK(&gpublic->devices);
-	
+
 	return CLI_SUCCESS;
 }
 
diff --git a/manager.c b/manager.c
index 0f9a0ca..f30ec55 100644
--- a/manager.c
+++ b/manager.c
@@ -3,12 +3,12 @@
 #endif /* HAVE_CONFIG_H */
 
 #ifdef BUILD_MANAGER /* no manager, no copyright */
-/* 
+/*
    Copyright (C) 2009 - 2010
-   
+
    Artem Makhutov <artem@makhutov.org>
    http://www.makhutov.org
-   
+
    Dmitry Vagin <dmitry2004@yandex.ru>
 
    bg <bg_one@mail.ru>
@@ -20,6 +20,8 @@
 #include <asterisk/strings.h>			/* ast_strlen_zero() */
 #include <asterisk/callerid.h>			/* ast_describe_caller_presentation */
 
+#include "ast_compat.h"				/* asterisk compatibility fixes */
+
 #include "manager.h"
 #include "chan_dongle.h"			/* devices */
 #include "helpers.h"				/* ITEMS_OF() send_ccwa_set() send_reset() send_sms() send_ussd() */
@@ -118,7 +120,7 @@ static int manager_show_devices (struct mansession* s, const struct message* m)
 	astman_append (s, "Event: DongleShowDevicesComplete\r\n");
 	if(!ast_strlen_zero (id))
 		astman_append (s, "ActionID: %s\r\n", id);
-	astman_append (s, 
+	astman_append (s,
 		"EventList: Complete\r\n"
 		"ListItems: %zu\r\n"
 		"\r\n",
@@ -176,7 +178,7 @@ static int manager_send_sms (struct mansession* s, const struct message* m)
 	const char*	msg;
 	int		status;
 	void * msgid;
-	
+
 	if (ast_strlen_zero (device))
 	{
 		astman_send_error (s, m, "Device not specified");
@@ -218,7 +220,7 @@ static int manager_send_pdu (struct mansession* s, const struct message* m)
 	const char*	msg;
 	int		status;
 	void * msgid;
-	
+
 	if (ast_strlen_zero (device))
 	{
 		astman_send_error (s, m, "Device not specified");
@@ -342,11 +344,11 @@ static char * espace_newlines(const char * text)
 				escaped[j++] = 'n';
 			} else {
 				escaped[j++] = text[i];
-			}	
+			}
 		}
 		escaped[j] = 0;
 	}
-	
+
 	return escaped;
 }
 
@@ -605,13 +607,13 @@ static const struct dongle_manager
 	const char*	name;
 	const char*	brief;
 	const char*	desc;
-} dcm[] = 
+} dcm[] =
 {
 	{
-	manager_show_devices, 
+	manager_show_devices,
 	EVENT_FLAG_SYSTEM | EVENT_FLAG_REPORTING,
-	"DongleShowDevices", 
-	"List Dongle devices", 
+	"DongleShowDevices",
+	"List Dongle devices",
 	"Description: Lists Dongle devices in text format with details on current status.\n\n"
 	"DongleShowDevicesComplete.\n"
 	"Variables:\n"
@@ -619,9 +621,9 @@ static const struct dongle_manager
 	"	Device:   <name>	Optional name of device.\n"
 	},
 	{
-	manager_send_ussd, 
+	manager_send_ussd,
 	EVENT_FLAG_CALL,
-	"DongleSendUSSD", 
+	"DongleSendUSSD",
 	"Send a ussd command to the dongle.",
 	"Description: Send a ussd message to a dongle.\n\n"
 	"Variables: (Names marked with * are required)\n"
@@ -630,10 +632,10 @@ static const struct dongle_manager
 	"	*USSD:    <code>	The ussd code that will be send to the device.\n"
 	 },
 	{
-	manager_send_sms, 
+	manager_send_sms,
 	EVENT_FLAG_CALL,
-	"DongleSendSMS", 
-	"Send a SMS message.", 
+	"DongleSendSMS",
+	"Send a SMS message.",
 	"Description: Send a SMS message from a dongle.\n\n"
 	"Variables: (Names marked with * are required)\n"
 	"	ActionID: <id>		Action ID for this transaction. Will be returned.\n"
@@ -642,10 +644,10 @@ static const struct dongle_manager
 	"	*Message: <message>	The SMS message that will be send.\n"
 	},
 	{
-	manager_send_pdu, 
+	manager_send_pdu,
 	EVENT_FLAG_CALL,
-	"DongleSendPDU", 
-	"Send a PDU of message.", 
+	"DongleSendPDU",
+	"Send a PDU of message.",
 	"Description: Send a PDU of message from a dongle.\n\n"
 	"Variables: (Names marked with * are required)\n"
 	"	ActionID: <id>		Action ID for this transaction. Will be returned.\n"
@@ -653,9 +655,9 @@ static const struct dongle_manager
 	"	*PDU:     <PDU>		The PDU of SMS.\n"
 	},
 	{
-	manager_ccwa_set, 
+	manager_ccwa_set,
 	EVENT_FLAG_CONFIG,
-	"DongleSetCCWA", 
+	"DongleSetCCWA",
 	"Enable/Disabled Call-Waiting on a dongle.",
 	"Description: Enable/Disabled Call-Waiting on a dongle.\n\n"
 	"Variables: (Names marked with * are required)\n"
@@ -666,8 +668,8 @@ static const struct dongle_manager
 	{
 	manager_reset,
 	EVENT_FLAG_SYSTEM | EVENT_FLAG_CONFIG,
-	"DongleReset", 
-	"Reset a dongle.", 
+	"DongleReset",
+	"Reset a dongle.",
 	"Description: Reset a dongle.\n\n"
 	"Variables: (Names marked with * are required)\n"
 	"	ActionID: <id>		Action ID for this transaction. Will be returned.\n"
@@ -676,8 +678,8 @@ static const struct dongle_manager
 	{
 	manager_restart,
 	EVENT_FLAG_SYSTEM | EVENT_FLAG_CONFIG,
-	"DongleRestart", 
-	"Restart a dongle.", 
+	"DongleRestart",
+	"Restart a dongle.",
 	"Description: Restart a dongle.\n\n"
 	"Variables: (Names marked with * are required)\n"
 	"	ActionID: <id>		Action ID for this transaction. Will be returned.\n"
@@ -687,8 +689,8 @@ static const struct dongle_manager
 	{
 	manager_stop,
 	EVENT_FLAG_SYSTEM | EVENT_FLAG_CONFIG,
-	"DongleStop", 
-	"Stop a dongle.", 
+	"DongleStop",
+	"Stop a dongle.",
 	"Description: Stop a dongle.\n\n"
 	"Variables: (Names marked with * are required)\n"
 	"	ActionID: <id>		Action ID for this transaction. Will be returned.\n"
@@ -698,8 +700,8 @@ static const struct dongle_manager
 	{
 	manager_start,
 	EVENT_FLAG_SYSTEM | EVENT_FLAG_CONFIG,
-	"DongleStart", 
-	"Start a dongle.", 
+	"DongleStart",
+	"Start a dongle.",
 	"Description: Start a dongle.\n\n"
 	"Variables: (Names marked with * are required)\n"
 	"	ActionID: <id>		Action ID for this transaction. Will be returned.\n"
@@ -708,8 +710,8 @@ static const struct dongle_manager
 	{
 	manager_remove,
 	EVENT_FLAG_SYSTEM | EVENT_FLAG_CONFIG,
-	"DongleRemove", 
-	"Remove a dongle.", 
+	"DongleRemove",
+	"Remove a dongle.",
 	"Description: Remove a dongle.\n\n"
 	"Variables: (Names marked with * are required)\n"
 	"	ActionID: <id>		Action ID for this transaction. Will be returned.\n"
@@ -719,8 +721,8 @@ static const struct dongle_manager
 	{
 	manager_reload,
 	EVENT_FLAG_SYSTEM | EVENT_FLAG_CONFIG,
-	"DongleReload", 
-	"Reload a module configuration.", 
+	"DongleReload",
+	"Reload a module configuration.",
 	"Description: Reload the module configuration.\n\n"
 	"Variables: (Names marked with * are required)\n"
 	"	ActionID: <id>		Action ID for this transaction. Will be returned.\n"
@@ -733,7 +735,7 @@ EXPORT_DEF void manager_register()
 	unsigned i;
 #if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
 	struct ast_module* module = self_module();
-#endif
+#endif /* ^13+ */
 
 	for(i = 0; i < ITEMS_OF(dcm); i++)
 	{
@@ -742,9 +744,9 @@ EXPORT_DEF void manager_register()
 			module, dcm[i].brief, dcm[i].desc);
 #elif ASTERISK_VERSION_NUM >= 110000 /* 11+ */
 		ast_manager_register2 (dcm[i].name, dcm[i].authority, dcm[i].func, NULL, dcm[i].brief, dcm[i].desc);
-#else
+#else /* 11- */
 		ast_manager_register2 (dcm[i].name, dcm[i].authority, dcm[i].func, dcm[i].brief, dcm[i].desc);
-#endif
+#endif /* ^11- */
 	}
 }
 
